<%
	' enctypetest.asp - script which displays a form to use in testing enctype encoding for 
	' imode, wml, or xhtml content. Script is able to test both
	' GET and POST methods.
	'
	' This script is based on nonalpha_chars.asp, which is used by the TriMode Browser tests.
	'
	' usage: enctypetest.asp?content=[WML|IMODE|XHTML]&method=[get|post]&enctypecode=[Set|Unset|Invalid]
	' notes: case is significant in atribute values;  iMode HTML and WML use <input> field;
	'   XHTML uses <textarea> element instead
	''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	
	varStartNum = 33		'starting character of set  
	varEndNum = 126			'ending character of set
	exclDigFrom = 48		'chars excluded from set, i.e. digits, upper and lowercase letters
	exclDigTo = 57
	exclCapsFrom = 65
	exclCapsTo = 90
	exclLCaseFrom = 97
	exclLCaseTo = 122
	
	testSize = 8			' size of the test string, in characters
	
    content=Request.QueryString("content")
    method=Request.QueryString("method") 
    enctypeCode=Request.QueryString("enctypeCode")
    enctypeStr = ""

    ' default attributes
    if (content = "") then
		content = "IMODE"
	end if
	if (method = "") then
		method = "GET"
	end if
    if (enctypeCode = "Unset") then
		enctypeStr = ""
    elseif (enctypeCode = "Set") then
		enctypeStr = "enctype='application/x-www-form-urlencoded'"
    elseif  (enctypeCode = "Invalid") then
		enctypeStr = "enctype='foo'"
	end if


	' depending on type of content desired, output the appropriate header and starting content
    if (content = "IMODE") then
		Response.Write "<html>" & vbCrLf & "<head><title>Enctype " & enctypecode & "</title></head>" & vbCrLf & "<body>" & vbCrLf
		Response.Write "<h4>Enctype " & enctypecode & "</h4>" & vbCrLf 
	elseif (content = "XHTML") then
		Response.Write "<?xml version='1.0'?>" & vbCrLf & "<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML Basic 1.1//EN' " & vbCrLf & "'http://www.w3.org/TR/xhtml-basic/xhtml-basic11.dtd'>" & vbCrLf
		Response.Write "<html xmlns='http://www.w3.org/1999/xhtml'>" & vbCrLf
		Response.Write "<head><title>Enctype " & enctypeCode & "</title></head>" & vbCrLf & "<body>" & vbCrLf
		Response.Write "<h4>Enctype " & enctypeCode & "</h4>" & vbCrLf
	else
		Response.ContentType="text/vnd.wap.wml"
		Response.Write "<?xml version='1.0'?>" & vbCrLf & "<!DOCTYPE wml PUBLIC '-//WAPFORUM//DTD WML 1.2//EN' 'http://www.wapforum.org/DTD/wml_1.2.xml'>" & vbCrLf
		Response.Write "<wml>" & vbCrLf & "<card title='Enctype" & enctypecode & "'>" & vbCrLf
		Response.Write "<p><big>Enctype " & enctypecode & "</big><br/>" & "</p>" & vbCrLf		
	end if

	' pick a random subset of 10 characters within the predefined nonalpha set; user selects same chars from handset
	Response.Write "<p>Enter the following chars into the input field in the order given.</p>" & vbCrLf
	Response.Write "<p>If a character displayed is not available on the user agent, enter 'p' in place of that char.</p>" & vbCrLf
	Randomize
	Response.Write "<p>"  & vbCrLf
	For varCounter = 1 to testSize
		intValue = Int((varEndNum - varStartNum + 1) * Rnd + varStartNum)
		' do while loop excludes characters picked that are digits or letters
		do while ( (intValue >= exclDigFrom and intValue <= exclDigTo) or (intValue >= exclCapsFrom and intValue <= exclCapsTo) or (intValue >= exclLCaseFrom and intValue <= exclLCaseTo))
			intValue = Int((varEndNum - varStartNum + 1) * Rnd + varStartNum)
		loop
		if (intValue = 36)and (content = "WML") then
			' this is a dollar sign - replace with two $$ for WML only
			Response.Write "$$"
		else
			Response.Write "&#" 
			Response.Write  intValue & ";" & " " 
		end if
	Next  
	Response.Write vbCrLf
	Response.Write "</p>"  & vbCrLf

	' output appropriate form content and footer based on content type specified
	if (content = "IMODE") then
		Response.Write "<form method='" & method & "  " & enctypestr & "  " & "' action='checkenctype.asp'>" & vbCrLf
		Response.Write "<p><input type='hidden' name='content' value='" & content & "'/></p>" & vbCrLf
		Response.Write "<p><input type='text' name='textfield' size='10'/></p>" & vbCrLf
		Response.Write "<p><input type='submit' name='submit' value='submit'/></p>" & vbCrLf
		Response.Write "</form>" & vbCrLf & "</body>" & vbCrLf & "</html>"
	elseif (content = "XHTML") then
		Response.Write "<form method='" & method & "' " & enctypestr & "  " &"action='checkenctype.asp'>" & vbCrLf
		Response.Write "<p><input type='hidden' name='content' value='" & content & "'/>" & vbCrLf
		Response.Write "<input type='hidden' name='enctypeCode' value='" & enctypeCode & "'/>" & vbCrLf
		Response.Write "<textarea name='textfield' rows='2' cols='5'></textarea><br/>" & vbCrLf
		Response.Write "<input type='submit' name='submit' value='submit'/></p>" & vbCrLf
		Response.Write "</form>" & vbCrLf
		Response.Write "<p><a href='../../PostResults.xhtml'>Post Results</a><br/>" & vbCrLr
		Response.Write "</p>" & vbCrLf
		Response.Write "</body>" & vbCrLf & "</html>"
	else
		Response.Write "<p><input name='temp' size='10'/></p>" & vbCrLf
		Response.Write "<p><anchor>Submit" & vbCrLf
		Response.Write "	<go href='checkenctype.asp' method='" & method & "'>" & vbCrLf
		Response.Write "		<postfield name='content' value='WML'/>" & vbCrLf
		Response.Write "		<postfield name='textfield' value='$(temp)'/>" &vbCrLf    
		Response.Write "	</go>" & vbCrLf & "	</anchor></p>" & vbCrLf & "</card>" & vbCrLf & "</wml>"
	end if
%>
